#ifndef _CLOCK_H
#define _CLOCK_H
#include "TriangleMesh.h"

//#define CLOCK_DEBUG

class Clock
{
  public:
    Clock(TriangleMesh& mesh);
    
    void Init();
    void Loop();
    
    static size_t AppendNum(char* Buffer, int Num, char Lead);
    static bool CheckPeriod(unsigned long& Timer, unsigned long PeriodMS);

  private:
    enum DisplayModes { eMode12Hour, eMode24Hour, eModeTemperature, eModeLAST };
    void Randomize();
    void Display12Hour(int DisplayHour24, char* buffer);
    void DisplayTemperature(char* buffer);
    void Splash(int DelayMS, bool Flat);
    void Config(byte& value, byte Min, byte Max, char Pad, byte LabelIdx);
    void Config();
    void Mode();
    
    TriangleMesh& m_Mesh;
    unsigned long m_UpdateTimer;
    unsigned long m_HoldoffTimer;
    int m_DisplayedMinute;
    word m_CfgTouchedCells;
    word m_AltTouchedCells;
    byte m_DisplayMode;
    bool m_bEggShown;
    
    static prog_uint32_t pLabels[] PROGMEM;
    static prog_uint32_t pTime[] PROGMEM;
    static prog_uint32_t pDate[] PROGMEM;
    static prog_uint32_t pMEW[] PROGMEM;
    static prog_uint32_t pEgg[] PROGMEM;
};

#endif
