#ifndef _TOUCH_H
#define _TOUCH_H

class Touch
{
  // Simplified 4-wire touch screen interface.  Landscape orientation.  
  // Treats the touch screen as a 4x4 grid of de-bounced buttons
  public:
    // pins and pressure 
    void Init(int pinXpos, int pinXneg, int pinYpos, int pinYneg, int ThresholdPressure = 128);
    // treat screen as a button
    bool Pressed();
    // LANDSCAPE
    int Col();
    // LANDSCAPE
    int Row();
    // cell on 4x4 grid, as a bit
    word TouchedCell();
  
  private:
    int m_PinXpos;
    int m_PinXneg;
    int m_PinYpos;
    int m_PinYneg;
  
    int Pressure();
    int m_iPrevReading;
    int m_iPrevState;
    unsigned long m_iTransitionTimeMS;
  
    int m_iThresholdPressure;  
};

extern Touch touch;

#endif

